<?php

// $Id: pnadmin.php,v 1.2 2002/11/05 vivian

// ----------------------------------------------------------------------

// POST-NUKE vquiz module (Quiz generator)

// Copyright (C) 2002 by Vivian Synteta

// http://tecfa.unige.ch/~paraskev

// ----------------------------------------------------------------------

// LICENSE

//

// This program is free software; you can redistribute it and/or

// modify it under the terms of the GNU General Public License (GPL)

// as published by the Free Software Foundation; either version 2

// of the License, or (at your option) any later version.

//

// This program is distributed in the hope that it will be useful,

// but WIthOUT ANY WARRANTY; without even the implied warranty of

// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

// GNU General Public License for more details.

//

// To read the license please visit http://www.gnu.org/copyleft/gpl.html

// ----------------------------------------------------------------------

// Original Author of file: Vivian Synteta

// Purpose of file:  Template administration display functions

// ----------------------------------------------------------------------



// todo: manage all exceptions (including sql)





// main functions for the admin interface according to actions

// -----------------------------------------------------------



// produce main menu for admin

function vquiz_admin_main() {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_ADMIN)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }

  $modname = "vquiz";

  $output->SetOutputMode(_PNH_KEEPOUTPUT);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();

  

  $output->Title(_ADMININTERFACE);



  $quizzestable = $pntable['vquiz_quizzes'];

  $result1=$dbconn->Execute("SELECT * FROM $quizzestable");



  $output->FormStart(pnModURL('vquiz', 'admin', 'newquiz'));

  $output->TableStart('','',1);

  $row1 = array();

  $row1[] = _ID;

  $row1[] = _NAME;

  $row1[] = _NOQUEST;

  $row1[] = _NOANS;

  $row1[] = _TRIALS;

  $row1[] = "-";

  $row1[] = "-";

  $row1[] = "-";

  $row1[] = "-";

  $row1[] = _ACTIVE;

  $row1[] = _INACTIVE;

  $output->TableAddRow($row1, 'left');



  while(list($quizid, $qname, $noquest, $noans, $trials, $active) = $result1->fields) {

    $result1->MoveNext();  

    $row2 = array();

    $output->SetOutputMode(_PNH_RETURNOUTPUT);

    if ( $active == 1) {

      $row2[] = $output->BoldText($quizid);

      $row2[] = $output->BoldText($qname);

      $row2[] = $output->BoldText($noquest);

      $row2[] = $output->BoldText($noans); 

      $row2[] = $output->BoldText($trials); 

    } else {

      $row2[] = $output->Text($quizid);

      $row2[] = $output->Text($qname);

      $row2[] = $output->Text($noquest);

      $row2[] = $output->Text($noans); 

      $row2[] = $output->Text($trials); 

    }



    $row2[] = $output->URL(pnModURL('vquiz',

				    'admin',

				    'edit', array('quizid' => $quizid)),

			   _EDIT); 

    $row2[] = $output->URL(pnModURL('vquiz',

				     'admin',

				     'delete', array('quizid' => $quizid)),

			             _DELETE); 

    $row2[] = $output->URL(pnModURL('vquiz',

				    'admin',

				    'halloffame', array('quizid' => $quizid)),

			   _HALLOFFAME); 

    $row2[] = $output->URL(pnModURL('vquiz',

				    'admin',

				    'test', array('quizid' => $quizid)),

			   _TEST); 

    if ($active == 1) {

      $row2[] = $output->BoldText(_ACTIV);

      $row2[] = $output->URL(pnModURL('vquiz',

				      'admin',

				      'deactivate', array('quizid' => $quizid)),

			     _DEACTIVATE); 

    } else {

      $row2[] = $output->Text(_INACTIV); 

      $row2[] = $output->URL(pnModURL('vquiz',

				      'admin',

				      'activate', array('quizid' => $quizid)),

			     _ACTIVATE); 

    }



    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);

    $output->TableAddRow($row2, 'left');

  }

  

  $row3 = array();

  $output->SetOutputMode(_PNH_RETURNOUTPUT);

  $row3[] = $output->Text(_NEWQUIZ);

  $row3[] = $output->FormText('qname', '', 20);

  $row3[] = $output->FormText('noquest', '', 2);

  $row3[] = $output->FormText('noans', '', 2);

  $row3[] = $output->FormText('trials', '1', 2);

  $row3[] = $output->FormSubmit('Submit');

  $row3[] = $output->URL(pnModURL('vquiz',

				     'admin',

				     'deleteall'),

			             _DELETEALL); 

  $row3[] = $output->Text('-');

  $row3[] = $output->Text('-');

  $row3[] = $output->URL(pnModURL('vquiz',

				     'admin',

				     'activateall'),

			             _ACTIVATEALL); 

  $row3[] = $output->URL(pnModURL('vquiz',

				     'admin',

				     'deactivateall'),

			             _DEACTIVATEALL); 





  $output->SetOutputMode(_PNH_KEEPOUTPUT);

  $output->SetInputMode(_PNH_VERBATIMINPUT);

  $output->TableAddRow($row3, 'left');

  $output->Linebreak(2);

  $output->TableEnd();

  $output->FormEnd();



  return $output->GetOutput();

}





// footer of vquiz_quizzes table for new quiz

function vquiz_admin_newquiz($args) {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_ADD)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($qname, $noquest, $noans, $trials)= pnVarCleanFromInput('qname', 'noquest', 'noans', 'trials');

  extract($args);

  $output->SetOutputMode(_PNH_KEEPOUTPUT);



  $output->Title(_ACTIONNEWQUIZ);

  $output->Title("Quiz -$qname ($noquest,$noans)-");



  $output->FormStart(pnModURL('vquiz', 'admin', 'save'));

  $row1 = array();

  $question = array();

  $answer = array();

  $feedback = array();

  $points = array();

  for ($i=1;$i<=$noquest;$i++) {

    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);

    $row1[] = $output->LineBreak(2);

    $row1[] = $output->BoldText("Question $i: ");

    $row1[] = $output->FormText("question[$i]", "", 50, 255);

    $row1[] = $output->LineBreak(2);

    for ($j=1;$j<=$noans;$j++) {

      $row1[] = $output->BoldText("Answer $j: ");

      $row1[] = $output->FormText("answer[$i][$j]", "", 50, 255);

      $row1[] = $output->BoldText("Feedback $j: ");

      $row1[] = $output->FormText("feedback[$i][$j]", "", 50, 255);

      $row1[] = $output->BoldText("Points? ");

      $row1[] = $output->FormText("points[$i][$j]", "", 2);

      $row1[] = $output->LineBreak(2);

    }

  }



  $row1[] = $output->FormHidden('qname', $qname);

  $row1[] = $output->FormHidden('noquest', $noquest);

  $row1[] = $output->FormHidden('noans', $noans);

  $row1[] = $output->FormHidden('trials', $trials);

  $row1[] = $output->LineBreak(2);

  $row1[] = $output->FormSubmit(_SUBMIT);

  $row1[] = $output->FormEnd();

  return $output->GetOutput();

} 





// save the new quiz

function vquiz_admin_save($args) {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_ADD)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($question, $answer, $feedback, $points, $qname, $noquest, $noans, $trials) = pnVarCleanFromInput('question', 'answer', 'feedback', 'points', 'qname', 'noquest', 'noans', 'trials');

  extract($args);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];



  $sql1 = "INSERT INTO $quizzestable (qname, noquest, noans, trials) VALUES ('".pnVarPrepForStore($qname)."', '".pnVarPrepForStore($noquest)."', '".pnVarPrepForStore($noans)."', '".pnVarPrepForStore($trials)."')";

  $result1=$dbconn->Execute($sql1);

  $sql2 = "SELECT quizid FROM $quizzestable WHERE qname = '".pnVarPrepForStore($qname)."'";

  $result2=$dbconn->Execute($sql2);



  $quizid = $result2->Fields('quizid');



  for ($i=1; $i<=$noquest;$i++) {

    $sql3 = "INSERT INTO $questionstable VALUES (".pnVarPrepForStore($quizid).", $i, '".pnVarPrepForStore($question[$i])."')";

    $result3=$dbconn->Execute($sql3);

    for ($j=1; $j<=$noans;$j++) {

      $tmp1 = $answer[$i][$j];

      $tmp2 = $feedback[$i][$j];

      $tmp3 = $points[$i][$j];

      $sql4 = "INSERT INTO $answerstable VALUES (".pnVarPrepForStore($quizid).", $i, $j, '".pnVarPrepForStore($tmp1)."', '".pnVarPrepForStore($tmp2)."', '".pnVarPrepForStore($tmp3)."')";

      $result4=$dbconn->Execute($sql4);

    }

  }



  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}





// test a quiz by running it

function vquiz_admin_test($args) {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_ADMIN)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  $modname = "vquiz";

  $quizid = pnVarCleanFromInput('quizid');



  $output->SetOutputMode(_PNH_KEEPOUTPUT);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();

  

  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];

  $halloffametable = $pntable['vquiz_halloffame'];  



  $sql1 = "SELECT * FROM $quizzestable WHERE quizid='".pnVarPrepForStore($quizid)."'";

  $result1=$dbconn->Execute($sql1);

  list($quizid, $qname, $noquest, $noans, $trials) = $result1->fields;



  $current_user = pnUserGetVar('uname');

  $sql4 = "SELECT * FROM $halloffametable WHERE quizid='$quizid' AND quser='$current_user'";

  $result4 = $dbconn->Execute($sql4);

  $trialsdone = $result4->RecordCount();

  if ($trialsdone >= $trials) {

    $output->BoldText(_QUIZDONE);

  } else {

    $answers = array();

    $output->Title(_RUNNINGQUIZ.": '$qname'");

    

    $output->FormStart(pnModURL('vquiz', 'admin', 'score', array('answers' => $answers)));

    

    for ($i=1;$i<=$noquest;$i++) {

      $sql2 = "SELECT question FROM $questionstable WHERE quizid='$quizid' AND questid='$i'";

      $result2=$dbconn->Execute($sql2);

      $current_question = $result2->Fields('question');

      

      $output->SetOutputMode(_PNH_KEEPOUTPUT);

      $output->SetInputMode(_PNH_VERBATIMINPUT);

      $output->LineBreak(2);

      $output->BoldText("$i) $current_question");

      $output->LineBreak(1);

      for ($j=1;$j<=$noans;$j++) {

	$sql3 = "SELECT answer FROM $answerstable WHERE quizid='$quizid' AND questid='$i' AND ansid='$j'";

	$result3=$dbconn->Execute($sql3);

	$current_answer = $result3->Fields('answer');

	$answercode = "$i-$j";

	$output->FormCheckbox("answers[$i]", "",$answercode, 'radio');

	$output->Text("$current_answer");

	$output->LineBreak(2);

      }

    }

    $time = microtime();

    $output->FormHidden('quizid', $quizid);

    $output->FormHidden('time', $time);

    $output->LineBreak(2);

    $output->FormSubmit(_SUBMIT);

    $output->FormEnd();

  }

  return $output->GetOutput();

}





// edit an existing quiz

function vquiz_admin_edit($args) {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_EDIT)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }

  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizid= pnVarCleanFromInput('quizid');

  extract($args);



  $output->Title(_ACTIONEDITING);



  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];



  $sql1 = "SELECT * FROM $quizzestable WHERE quizid='$quizid'";

  $result1=$dbconn->Execute($sql1);

  list($quizid, $qname, $noquest, $noans, $trials) = $result1->fields;



  $output->Title(_EDITQUIZ.": '$qname'");



  $output->FormStart(pnModURL('vquiz', 'admin', 'update'));

  $row1 = array();



  for ($i=1;$i<=$noquest;$i++) {

    $sql2 = "SELECT question FROM $questionstable WHERE quizid='$quizid' AND questid='$i'";

    $result2=$dbconn->Execute($sql2);

    $current_question = $result2->Fields('question');



    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);

    $row1[] = $output->LineBreak(2);

    $row1[] = $output->BoldText("Question $i: ");

    $row1[] = $output->FormText("question[$i]", "$current_question", 50, 255);

    $row1[] = $output->LineBreak(2);

    for ($j=1;$j<=$noans;$j++) {

      $sql3 = "SELECT answer,feedback,points FROM $answerstable WHERE quizid='$quizid' AND questid='$i' AND ansid='$j'";

      $result3=$dbconn->Execute($sql3);

      $current_answer = $result3->Fields('answer');

      $current_feedback = $result3->Fields('feedback');

      $current_points = $result3->Fields('points');



      $row1[] = $output->BoldText("Answer $j: ");

      $row1[] = $output->FormText("answer[$i][$j]", "$current_answer", 50, 255);

      $row1[] = $output->BoldText("Feedback $j: ");

      $row1[] = $output->FormText("feedback[$i][$j]", "$current_feedback", 50,255);



      $row1[] = $output->BoldText("Points? ");

      $row1[] = $output->FormText("points[$i][$j]", "$current_points", 2);

      $row1[] = $output->LineBreak(2);

    }

  }

  $row1[] = $output->FormHidden('quizid', $quizid);

  $row1[] = $output->FormHidden('qname', $qname);

  $row1[] = $output->FormHidden('noquest', $noquest);

  $row1[] = $output->FormHidden('noans', $noans);

  $row1[] = $output->FormHidden('trials', $trials);

  $row1[] = $output->LineBreak(2);

  $row1[] = $output->FormSubmit(_SUBMIT);

  $row1[] = $output->FormEnd();

  return $output->GetOutput();

}







// delete an existing quiz from all tables

function vquiz_admin_delete($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizid= pnVarCleanFromInput('quizid');

  extract($args); 



  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];

  $halloffametable = $pntable['vquiz_halloffame'];



  // extract info from db

  $sql1 = "DELETE FROM $quizzestable WHERE quizid=$quizid";

  $sql2 = "DELETE FROM $questionstable WHERE quizid=$quizid";

  $sql3 = "DELETE FROM $answerstable WHERE quizid=$quizid";

  $sql4 = "DELETE FROM $halloffametable WHERE quizid=$quizid";



  $result1 = $dbconn->Execute($sql1);

  $result2 = $dbconn->Execute($sql2);

  $result3 = $dbconn->Execute($sql3);

  $result4 = $dbconn->Execute($sql4);



  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}





// delete all quizzes

function vquiz_admin_deleteall($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];

  $halloffametable = $pntable['vquiz_halloffame'];



  // extract info from db

  $sql1 = "DELETE FROM $quizzestable";

  $sql2 = "DELETE FROM $questionstable";

  $sql3 = "DELETE FROM $answerstable";

  $sql4 = "DELETE FROM $halloffametable";



  $result1 = $dbconn->Execute($sql1);

  $result2 = $dbconn->Execute($sql2);

  $result3 = $dbconn->Execute($sql3);

  $result4 = $dbconn->Execute($sql4);



  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}





// delete the score of a user from the halloffame

function vquiz_admin_deleteuser($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  list($quizid, $score, $date, $time, $quser)= pnVarCleanFromInput('quizid', 'score', 'date', 'time', 'quser');

  extract($args); 



  $halloffametable = $pntable['vquiz_halloffame'];



  // extract info from db

  $sql1 = "DELETE FROM $halloffametable WHERE quizid=$quizid AND score=$score AND date='$date' AND time='$time' AND quser='$quser'";

  $result1 = $dbconn->Execute($sql1);



  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}





// activate a quiz to appear in the users interface

function vquiz_admin_activate($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizid= pnVarCleanFromInput('quizid');

  extract($args);



  $quizzestable = $pntable['vquiz_quizzes'];

  $sql1 = "UPDATE $quizzestable SET active='1' WHERE quizid='".pnVarPrepForStore($quizid)."'";

  $result1=$dbconn->Execute($sql1);



  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}



//deactivate quiz not to be seen by users

function vquiz_admin_deactivate($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizid= pnVarCleanFromInput('quizid');

  extract($args);



  $quizzestable = $pntable['vquiz_quizzes'];

  $sql1 = "UPDATE $quizzestable SET active='0' WHERE quizid='".pnVarPrepForStore($quizid)."'";

  $result1=$dbconn->Execute($sql1);

  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}





// activate all quizzes

function vquiz_admin_activateall($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();

  $quizzestable = $pntable['vquiz_quizzes'];

  $sql1 = "UPDATE $quizzestable SET active='1'";

  $result1=$dbconn->Execute($sql1);



  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}





// deactivate all quizzes

function vquiz_admin_deactivateall($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();

  $quizzestable = $pntable['vquiz_quizzes'];

  $sql1 = "UPDATE $quizzestable SET active='0'";

  $result1=$dbconn->Execute($sql1);



  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}





// update the quiz according to changes edited

function vquiz_admin_update($args) {

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_ADD)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  list($question, $answer, $feedback, $points, $quizid, $noquest, $noans, $trials) = pnVarCleanFromInput('question', 'answer', 'feedback', 'points', 'quizid', 'noquest', 'noans', 'trials');

  extract($args);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];



  for ($i=1; $i<=$noquest;$i++) {

    $sql3 = "UPDATE $questionstable SET question='".pnVarPrepForStore($question[$i])."' WHERE quizid='".pnVarPrepForStore($quizid)."' AND questid='$i'";

    $result3=$dbconn->Execute($sql3);

    for ($j=1; $j<=$noans;$j++) {

      $tmp1 = $answer[$i][$j];

      $tmp2 = $feedback[$i][$j];

      $tmp3 = $points[$i][$j];



      $sql4 = "UPDATE $answerstable SET answer='".pnVarPrepForStore($tmp1)."', feedback='".pnVarPrepForStore($tmp2)."', points='".pnVarPrepForStore($tmp3)."' WHERE quizid='".pnVarPrepForStore($quizid)."' AND questid='$i' AND ansid='$j'";

      $result4=$dbconn->Execute($sql4);

    }

  }

  pnRedirect(pnModURL('vquiz', 'admin', 'main'));

}







// show score for the quiz

function vquiz_admin_score($args) {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_COMMENT)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  $output->SetOutputMode(_PNH_KEEPOUTPUT);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  list($answers, $quizid, $time)= pnVarCleanFromInput('answers', 'quizid', 'time');

  extract($args); 



  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];

  $halloffametable = $pntable['vquiz_halloffame'];

  $current_user = pnUserGetVar('uname');



  // avoid reloading of page "score"

  $sql = "SELECT time FROM $halloffametable WHERE quizid=$quizid AND quser='$current_user' AND time='$time'";

  $result = $dbconn->Execute($sql);

  if (!$result->EOF) {

    $output->BoldText(_QUIZDONE);    

  } else {

    $sql1 = "SELECT * FROM $quizzestable WHERE quizid=$quizid";

    $result1 = $dbconn->Execute($sql1);

    

    list($quizid, $qname, $noquest, $noans, $trials, $active) = $result1->fields;    

    if ($current_user == '') 

      $current_user = "anonymous";

    $output->Title(_QUIZSCORE." '$qname' "._ANDUSER." '$current_user'");

    

    $score = 0;     

    for ($i=1;$i<=$noquest;$i++) {

      $sql2 = "SELECT question FROM $questionstable WHERE quizid='$quizid' AND questid='$i'";

      $result2=$dbconn->Execute($sql2);

      $current_question = $result2->Fields('question');

      

      $output->SetOutputMode(_PNH_KEEPOUTPUT);

      $output->SetInputMode(_PNH_VERBATIMINPUT);

      $output->LineBreak(2);

      $output->BoldText("$i) $current_question");

      $output->LineBreak(1);

      

      // Bug correction Vquiz 1.0

      $questionidbms = strcspn($answers[$i], "-");

      $ansid = substr($answers[$i], $questionidbms+1);

/*

  $output->Text("questionid ".$questionidbms."<br />");

  $output->Text("answeri ".$answers[$i]."<br />");

  $output->Text("ansid ".$ansid."<br />");

*/     

      $sql3 = "SELECT answer, feedback, points FROM $answerstable WHERE quizid='$quizid' AND questid='$i' AND ansid='$ansid'";

      $result3=$dbconn->Execute($sql3);

      $current_answer = $result3->Fields('answer');

      $current_feedback = $result3->Fields('feedback');

      $current_points = $result3->Fields('points');

      $output->Text(_YOURANSWERIS.": $current_answer");

      $output->Linebreak(1);

      $output->Text(_YOURFEEDBACKIS.": $current_feedback");

      $output->Linebreak(1);

      $output->Text(_YOURPOINTSARE.": $current_points");

      

      // Calculate score

      $score = $score + $current_points;

    }

    

    $output->Linebreak(2);

    $output->Title(_YOURSCOREIS.": $score");

    $output->Linebreak(2);

    

    $output->URL(pnModURL('vquiz', 'admin', 'halloffame', array('quizid' => $quizid)), _VISITHALLOFFAME);

    $output->Linebreak(2);

    if ($current_user=='admin') {

      $output->URL(pnModURL('vquiz', 'admin', 'main'), _BACKTOADMIN);

    } else {

      $output->URL(pnModURL('vquiz', 'user', 'main'), _BACKTOUSER);

    }

  

    $halloffametable = $pntable['vquiz_halloffame'];

    $sql2 = "INSERT INTO $halloffametable (quizid, score, date, time, quser) VALUES ('".pnVarPrepForStore($quizid)."', '".pnVarPrepForStore($score)."', CURDATE(), '".pnVarPrepForStore($time)."', '".pnVarPrepForStore($current_user)."')";

    $result2 = $dbconn->Execute($sql2);

  }

    return $output->GetOutput();

}



// show hall of fame for current vquiz

function vquiz_admin_halloffame($args) {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_COMMENT)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }

  $output->SetOutputMode(_PNH_KEEPOUTPUT);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $quizid= pnVarCleanFromInput('quizid');

  extract($args); 



  $current_user = pnUserGetVar('uname');



  $quizzestable = $pntable['vquiz_quizzes'];

  $sql1 = "SELECT * FROM $quizzestable WHERE quizid='$quizid'";

  $result1 = $dbconn->Execute($sql1);



  $qname = $result1->Fields("qname");



  $halloffametable = $pntable['vquiz_halloffame'];

  $sql2 = "SELECT * FROM $halloffametable WHERE quizid='$quizid' ORDER BY score DESC";

  $result2 = $dbconn->Execute($sql2);



  $output->Title(_HALLOFFAMEFORQUIZ." '$qname'");

  $output->TableStart('','',1);

  $row1 = array();

  $output->SetOutputMode(_PNH_RETURNOUTPUT);

  $row1[] = $output->BoldText(_SCORE);

  $row1[] = $output->BoldText(_DATE);

//  $row1[] = $output->BoldText(_TIME);

  $row1[] = $output->BoldText(_USER);

  if (pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE))

    $row1[] = $output->Text("-");

  $output->SetOutputMode(_PNH_KEEPOUTPUT);

  $output->SetInputMode(_PNH_VERBATIMINPUT);

  $output->TableAddRow($row1, 'left');



  while(list($quizid, $score, $date, $time, $quser) = $result2->fields) {

    $row2 = array();

    $result2->MoveNext();  

    $output->SetOutputMode(_PNH_RETURNOUTPUT);

    $row2[] = $output->Text($score);

    $row2[] = $output->Text($date);

//    $row2[] = $output->Text($time);

    $row2[] = $output->Text($quser);

    if (pnSecAuthAction(0, 'vquiz::', '::', ACCESS_DELETE))

      $row2[] = $output->URL(pnModURL('vquiz',

				      'admin',

				      'deleteuser', array('quizid' => $quizid,'score' => $score, 'date' => $date, 'time' => $time, 'quser' => $quser)),

			     _DELETE); 

    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);

    $output->TableAddRow($row2, 'left');

  }

  $output->TableEnd();

  if ($current_user=='admin') {

    $output->URL(pnModURL('vquiz', 'admin', 'main'), _BACKTOADMIN);

  } else {

    $output->URL(pnModURL('vquiz', 'user', 'main'), _BACKTOUSER);

  }

  return $output->GetOutput();

}



?>

