<?php
// $Id: pninit.php,v 1.2 2002/11/05 vivian
// ----------------------------------------------------------------------
// POST-NUKE vquiz module (Quiz generator)
// Copyright (C) 2002 by Vivian Synteta
// http://tecfa.unige.ch/~paraskev
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Vivian Synteta
// Purpose of file:  Module initialisation
// ----------------------------------------------------------------------
/**
 * initialise the vquiz module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */

// this function parses the data stored in the array created in the file
// "pntables.php" and initialises the module ("vquiz" in our case)
// initialisation means that it creates automatically all tables in the db
// needed from the module and initialisation can be done from 
// the admin menu - modules - list - "module" - initialise

function vquiz_init()
{

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $quizzestable = $pntable['vquiz_quizzes'];
    $quizzescolumn = &$pntable['vquiz_quizzes_column'];
    $sql1 = "CREATE TABLE $quizzestable (
            $quizzescolumn[quizid] tinyint unsigned NOT NULL auto_increment,
            $quizzescolumn[qname] varchar(255) NOT NULL default '',
            $quizzescolumn[noquest] tinyint NOT NULL default 0,
            $quizzescolumn[noans] tinyint NOT NULL default 0,
            $quizzescolumn[trials] tinyint NOT NULL default 1,
            $quizzescolumn[active] tinyint(1) default 0,
            PRIMARY KEY(quizid))";
    $dbconn->Execute($sql1);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLE1FAILED);
        return false;
    }

    $questionstable = $pntable['vquiz_questions'];
    $questionscolumn = &$pntable['vquiz_questions_column'];
    $sql2 = "CREATE TABLE $questionstable (
            $questionscolumn[quizid] tinyint unsigned NOT NULL,
            $questionscolumn[questid] tinyint unsigned NOT NULL default '',
            $questionscolumn[question] varchar(255) NOT NULL default '')";
    $dbconn->Execute($sql2);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLE2FAILED);
        return false;
    }

    $answerstable = $pntable['vquiz_answers'];
    $answerscolumn = &$pntable['vquiz_answers_column'];
    $sql3 = "CREATE TABLE $answerstable (
            $answerscolumn[quizid] tinyint unsigned NOT NULL,
            $answerscolumn[questid] tinyint unsigned NOT NULL default '',
            $answerscolumn[ansid] tinyint unsigned NOT NULL default '',
            $answerscolumn[answer] varchar(255) NOT NULL default '',
            $answerscolumn[feedback] varchar(255) NOT NULL default '',
            $answerscolumn[points] tinyint default 0)";
    $dbconn->Execute($sql3);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLE3FAILED);
        return false;
    }


    $halloffametable = $pntable['vquiz_halloffame'];
    $halloffamecolumn = &$pntable['vquiz_halloffame_column'];
    $sql4 = "CREATE TABLE $halloffametable (
            $halloffamecolumn[quizid] tinyint unsigned NOT NULL,
            $halloffamecolumn[score] float(5) NOT NULL default 0,
            $halloffamecolumn[date] date NOT NULL default '0000-00-00',
            $halloffamecolumn[time] varchar(40) NOT NULL default '',
            $halloffamecolumn[quser] varchar(10) NOT NULL default '')";
    $dbconn->Execute($sql4);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _CREATETABLE4FAILED);
        return false;
    }

    // Set up an initial value for a module variable.  Note that all module
    // variables should be initialised with some value in this way rather
    // than just left blank, this helps the user-side code and means that
    // there doesn't need to be a check to see if the variable is set in
    // the rest of the code as it always will be
    pnModSetVar('vquiz', 'modname', 'vquiz');

    // Initialisation successful
    return true;
}

/**
 * delete the template module
 * This function is only ever called once during the lifetime of a particular
 * module instance
 */
function vquiz_delete()
{

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $sql1 = "DROP TABLE $pntable[vquiz_quizzes]";
    $dbconn->Execute($sql1);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DROPTABLE1FAILED);
        return false;
    }

    $sql2 = "DROP TABLE $pntable[vquiz_questions]";
    $dbconn->Execute($sql2);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DROPTABLE2FAILED);
        return false;
    }

    $sql3 = "DROP TABLE $pntable[vquiz_answers]";
    $dbconn->Execute($sql3);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DROPTABLE3FAILED);
        return false;
    }

    $sql4 = "DROP TABLE $pntable[vquiz_halloffame]";
    $dbconn->Execute($sql4);
    // Check for an error with the database code, and if so set an
    // appropriate error message and return
    if ($dbconn->ErrorNo() != 0) {
        pnSessionSetVar('errormsg', _DROPTABLE4FAILED);
        return false;
    }


    // Delete any module variables
    pnModDelVar('vquiz', 'modname');

    // Deletion successful
    return true;
}


?>
