<?php
// $Id: pntables.php,v 1.2 2002/11/05 vivian
// ----------------------------------------------------------------------
// POST-NUKE vquiz module (Quiz generator)
// Copyright (C) 2002 by Vivian Synteta
// http://tecfa.unige.ch/~paraskev
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WIthOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Vivian Synteta
// Purpose of file:  Module SQL tables stocked in pntable array
// ----------------------------------------------------------------------
/**
 * This function is called internally by the core whenever the module is
 * loaded.  It adds in the information
 */

// a function that stores in an array all the names of the tables
// in the following way:
// first perfix "nuke"
// secong prefix "modulename" ("vquiz" in our case)
// and last the name of the table or the field
// this function is used from the file "pninit.php" 
// that according to these names it creates the tables in the db 
function vquiz_pntables()
{
    // Initialise table array
    $pntable = array();

    // Get the name for the template item table.  This is not necessary
    // but helps in the following statements and keeps them readable
    $quizzes    = pnConfigGetVar('prefix') . '_vquiz_quizzes';
    $questions  = pnConfigGetVar('prefix') . '_vquiz_questions';
    $answers    = pnConfigGetVar('prefix') . '_vquiz_answers';
    $halloffame = pnConfigGetVar('prefix') . '_vquiz_halloffame';

    // Set the table name
    $pntable['vquiz_quizzes']    = $quizzes;
    $pntable['vquiz_questions']  = $questions;
    $pntable['vquiz_answers']    = $answers;
    $pntable['vquiz_halloffame'] = $halloffame;

    // Set the column names.  Note that the array has been formatted
    // on-screen to be very easy to read by a user.
    $pntable['vquiz_quizzes_column'] = 
array('quizid'  => $quizzes . '.quizid',
      'qname'   => $quizzes . '.qname',
      'noquest' => $quizzes . '.noquest',
      'noans'   => $quizzes . '.noans',
      'trials'   => $quizzes . '.trials',
      'active'  => $quizzes . '.active');
    $pntable['vquiz_questions_column'] = 
array('quizid'   => $questions . '.quizid',
      'questid'  => $questions . '.questid',
      'question' => $questions . '.question');
    $pntable['vquiz_answers_column'] = 
array('quizid'  => $answers . '.quizid',
      'questid' => $answers . '.questid',
      'ansid'   => $answers . '.ansid',
      'answer'  => $answers . '.answer',
      'feedback'=> $answers . '.feedback',
      'points'  => $answers . '.points');

    $pntable['vquiz_halloffame_column'] = 
array('quizid' => $halloffame . '.quizid',
      'score'  => $halloffame . '.score',
      'date'   => $halloffame . '.date',
      'time'   => $halloffame . '.time',
      'quser'  => $halloffame . '.quser');
    
    // Return the table information
    return $pntable;
}

?>
