<?php

// $Id: pnuser.php,v 1.2 2002/11/05 vivian

// ----------------------------------------------------------------------

// POST-NUKE vquiz module (Quiz generator)

// Copyright (C) 2002 by Vivian Synteta

// http://tecfa.unige.ch/~paraskev

// ----------------------------------------------------------------------

// LICENSE

//

// This program is free software; you can redistribute it and/or

// modify it under the terms of the GNU General Public License (GPL)

// as published by the Free Software Foundation; either version 2

// of the License, or (at your option) any later version.

//

// This program is distributed in the hope that it will be useful,

// but WIthOUT ANY WARRANTY; without even the implied warranty of

// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

// GNU General Public License for more details.

//

// To read the license please visit http://www.gnu.org/copyleft/gpl.html

// ----------------------------------------------------------------------

// Original Author of file: Vivian Synteta

// Purpose of file:  User interface functions

// ----------------------------------------------------------------------



// produce main menu for user (show active quizzes)

function vquiz_user_main() {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_COMMENT)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  $modname = "vquiz";

  $output->SetOutputMode(_PNH_KEEPOUTPUT);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();



  $halloffametable = $pntable['vquiz_halloffame'];  

  $quizzestable = $pntable['vquiz_quizzes'];

  $sql1 = "SELECT * FROM $quizzestable WHERE active='1'";

  $result1=$dbconn->Execute($sql1);



  $output->Title(_QUIZCHOICE);



  if ($result1->EOF) {

    $output->Text(_NOQUIZ);

  } else {

    $output->TableStart('','',1);

    $row1 = array();

    $row1[] = _NAME;

    $row1[] = _NOQUEST;

    $row1[] = _NOANS;

    $row1[] = _TRIALS;

    $row1[] = "-";

    $row1[] = "-";

    $output->TableAddRow($row1, 'left');

    $current_user = pnUserGetVar('uname');

    while(list($quizid, $qname, $noquest, $noans, $trials, $active) = $result1->fields) {

      $result1->MoveNext();  

      $row2 = array();

      $output->SetOutputMode(_PNH_RETURNOUTPUT);

      $row2[] = $output->Text($qname);

      $row2[] = $output->Text($noquest);

      $row2[] = $output->Text($noans);

      $row2[] = $output->Text($trials);



      $sql2 = "SELECT * FROM $halloffametable WHERE quizid='$quizid' AND quser='$current_user'";

      $result2 = $dbconn->Execute($sql2);

      $trialsdone = $result2->RecordCount();

      if ($trialsdone >= $trials) {

	$row2[] = $output->BoldText(_QUIZDONE);

      } else {

	$row2[] = $output->URL(pnModURL('vquiz',

					'user',

					'run', array('quizid' => $quizid)),

			       _RUN); 

      }

      $row2[] = $output->URL(pnModURL('vquiz',

				      'admin',

				      'halloffame', array('quizid' => $quizid)),

			     _HALLOFFAME); 

	

      $output->SetOutputMode(_PNH_KEEPOUTPUT);

      $output->SetInputMode(_PNH_VERBATIMINPUT);

      $output->TableAddRow($row2, 'left');

    }

    $output->Linebreak(2);

    $output->TableEnd();

  }

  return $output->GetOutput();

}





// produce main menu for user

function vquiz_user_run() {

  $output = new pnHTML();

  // Security check - important to do this as early as possible to avoid

  // potential security holes or just too much wasted processing

  if (!pnSecAuthAction(0, 'vquiz::', '::', ACCESS_COMMENT)) {

    $output->Text(_TEMPLATENOAUTH);

    return $output->GetOutput();

  }



  $modname = "vquiz";

  $quizid = pnVarCleanFromInput('quizid');



  $output->SetOutputMode(_PNH_KEEPOUTPUT);



  list($dbconn) = pnDBGetConn();

  $pntable = pnDBGetTables();

  

  $quizzestable = $pntable['vquiz_quizzes'];

  $questionstable = $pntable['vquiz_questions'];

  $answerstable = $pntable['vquiz_answers'];

  $halloffametable = $pntable['vquiz_halloffame'];  



  $sql1 = "SELECT * FROM $quizzestable WHERE quizid=$quizid";

  $result1=$dbconn->Execute($sql1);

  list($quizid, $qname, $noquest, $noans, $trials) = $result1->fields;



  $current_user = pnUserGetVar('uname');



  $sql4 = "SELECT * FROM $halloffametable WHERE quizid='$quizid' AND quser='$current_user'";

  $result4 = $dbconn->Execute($sql4);

  $trialsdone = $result4->RecordCount();

  if ($trialsdone >= $trials) {

    $output->BoldText(_QUIZDONE);

  } else {

    $answers = array();

    $output->Title(_RUNNINGQUIZ.": '$qname'");

    

    $output->FormStart(pnModURL('vquiz', 'admin', 'score', array('answers' => $answers)));

    

    for ($i=1;$i<=$noquest;$i++) {

      $sql2 = "SELECT question FROM $questionstable WHERE quizid='$quizid' AND questid='$i'";

      $result2=$dbconn->Execute($sql2);

      $current_question = $result2->Fields('question');

      

      $output->SetOutputMode(_PNH_KEEPOUTPUT);

      $output->SetInputMode(_PNH_VERBATIMINPUT);

      $output->LineBreak(2);

      $output->BoldText("$i) $current_question");

      $output->LineBreak(1);

      for ($j=1;$j<=$noans;$j++) {

	$sql3 = "SELECT answer FROM $answerstable WHERE quizid='$quizid' AND questid='$i' AND ansid='$j'";

	$result3=$dbconn->Execute($sql3);

	$current_answer = $result3->Fields('answer');

	$answercode = $i."-".$j;

	$output->FormCheckbox("answers[$i]", "", $answercode, 'radio');

	$output->Text("$current_answer");

	$output->LineBreak(2);

      }

    }

    $time = microtime();

    $output->FormHidden('quizid', $quizid);

    $output->FormHidden('time', $time);

    $output->LineBreak(2);

    $output->FormSubmit(_SUBMIT);

    $output->FormEnd();

  }

  return $output->GetOutput();

}



?>